///////////////////////////////////////////////////////////////////////////////////////////////////////
//Aufgabe 2 im Kapitel Bibliotheken
//Steuerung der Farbwert-Spreizung und der Sättigung mit Hilfe von Slidern der controlP5-Bibliothek
/////////////////////////////////////////////////////////////////////////////////////////////////////
import controlP5.*;//Bibliothek für graphische Bedienelemente (Buttons, Edits, Slider etc);
ControlP5 cp5;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
private boolean fertig = false;
private boolean tasteGedrueckt = false;
private PImage  bildOriginal, bildFertig; 
private int h,w;
private float a = 1;
private float werte = 1;
private float saettigung = 1;
private float zufallsZahl =0;
private int w1, h1;//Anzahl der Pixel in Breite und Höhe am Bildschirm
private int x1S, x2S;//x-Werte der SliderPosition 
private int y1S, y2S;//y-Werte der SliderPosition 
private ControlFont font;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void setup(){  
    size(800,250);
    background(200);
    textSize(24);fill(0);
    text("Werte und Sättigung", 40, 40); 
    textSize(16);
    text("Laden Sie mit Taste <l>oad ein jpg-Bild!", 40, 80); 
    text("Mit den dann angezeigten Slidern können Sie Werte und Sättigung ändern.", 40, 120); 
    text("Beachten Sie: Bei sehr großen Bildern kann es einige Sekunden dauern, bis das Bild verändet ist.", 40, 160);
    text("Mit Taste <s> speichern Sie das Bild im Programmordner.", 40, 200); 
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void draw() {
 
   frameRate(10);
   if(tasteGedrueckt == true){    
     bildFertig = bildBearbeitung(bildOriginal, werte, saettigung); 
     fertig = true;
   }
  
  if(fertig){ 
    //Längere Seite des Bildes wird auf auf 800 Pixel angezeigt  
    image(bildFertig,0,0,w/a,h/a);
   // fertig = false;
    zufallsZahl =(int) random(10);
    
    if(zufallsZahl ==1){
      //Die Methode Bildbearbeitung wird wieder durchgeführt
      //mit den aktuellen Werten der Slider
      tasteGedrueckt = true; 
    }else{
      //Solange wir die Methode bildBearbeitung nicht ausgeführt
      //und man kann die Slider bewegen.
      tasteGedrueckt = false;
    }
  } 
   
}
///////////////////////////////////////////////////////////////////////
void keyPressed() {
  
  if (key == 'l') {
      bildWaehlen();      
  }

  if (key == 's') {
      bildFertig.save("bildBearbeitet.jpg");
      noLoop();
  }
}
/////////////////////////////////////////////////////////////////////// 
//Die folgenden beiden Methoden bewirken, dass ein Lade-Dialog erscheint  
////////////////////////////////////////////////////////////////////////      
 void bildWaehlen(){
      selectInput("", "bildAusgewaehlt");
        while (bildOriginal == null) {
        delay(200);
      }
      loop();
      w =bildOriginal.width; h = bildOriginal.height  ;
      //Längere Seite des Bildes wird auf auf 800 Pixel angezeigt  
      //Verbleibende Seite proportional vergrößert/verkleinert
      if(w>=h){  
        a =(float)w/800; 
        w1 = int( w/a); 
        h1 = int((float)h/a); 
      }else{
        a = (float)h/800; 
        h1 =int( h/a);  
        w1 = int((float)w/a);  
      }   
      surface.setSize(w1,h1+50);
      //Positionen der Slider
      x1S = w1/2-280;x2S = w1/2+20;
      y1S = h1+20; y2S = h1+20;
      //delay(500);
      thread("SliderNutzen"); 
 } 
//////////////////////////////////////////////////////////////////////////// 
  void bildAusgewaehlt(File auswahl)
    {
      bildOriginal = loadImage(auswahl.getAbsolutePath());
    }
/////////////////////////////////////////////////////////////////////////////
void SliderNutzen(){
 PFont pfont = createFont("Arial",12,true); 
     ControlFont font = new ControlFont(pfont,14);
     
     cp5 = new ControlP5(this);  
    cp5.addSlider("werte")
     .setFont(font) //Schriftgröße
     .setRange(0.1, 3) //Zahlenbereich
     .setPosition(x1S, y1S)
     .setSize(150, 20)
     //Vordergrundfarbe des Sliders:
     .setColorForeground(color(0,0,60))
     //Vordergrundfarbe des Sliders aktiv:
     .setColorActive(color(80))
     //Hintergrundfarbe des Sliders:
     .setColorBackground(color(150))   
     //Farbe der Beschriftung außerhalb:
     .setColorLabel(color(0)) 
     //Farbe der Beschriftung innerhalb:
     .setColorValue(color(255)); 
     
   cp5.addSlider("saettigung")
     .setFont(font) //Schriftgröße
     .setRange(0, 4) //Zahlenbereich
     .setPosition(x2S, y2S)
     .setSize(150, 20)
     //Vordergrundfarbe des Sliders:
     .setColorForeground(color(0,0,60))
     //Vordergrundfarbe des Sliders aktiv:
     .setColorActive(color(80))
     //Hintergrundfarbe des Sliders:
     .setColorBackground(color(150))   
     //Farbe der Beschriftung außerhalb:
     .setColorLabel(color(0)) 
     //Farbe der Beschriftung innerhalb:
     .setColorValue(color(255));      
     
      tasteGedrueckt = true;
      

}

/////////////////////////////////////////////////////////////////////
//"werte" werden angehoben. Heller machen und trotzdem schwarz erhalten
 PImage bildBearbeitung(PImage bild, float werte, float saettigung){
    this.werte = werte;
    this.saettigung = saettigung;  
    float rotAnteil   = 0.0;
    float gruenAnteil = 0.0;
    float blauAnteil  = 0.0; 
    //Ab hier wird die Werte-Spreizung eingestellt
    colorMode(RGB,255,255,255);
    PImage bildBearbeitet = createImage(w,h,RGB);;
    bildOriginal = bild;
    for(int i = 0; i < w; i++){
     for(int j = 0; j < h; j++){
        color farbe = bildOriginal.pixels[i + j*w];
           rotAnteil = red(farbe)*werte;
           gruenAnteil = green(farbe)*werte;
           blauAnteil = blue(farbe)*werte;
       bildBearbeitet.pixels[i + j*w] = color(rotAnteil,gruenAnteil,blauAnteil);
     } 
   } 
   //Ab hier wird die Farbsättigung eingestellt
   colorMode(HSB,360,100,100);   
   float farbe, helligkeit, farbsaettigung;
    for(int i = 0; i < w; i++){
     for(int j = 0; j < h; j++){
        color farbWert = bildBearbeitet.pixels[i + j*w];
           farbe = hue(farbWert);
           farbsaettigung = saettigung*saturation(farbWert);
           if(saettigung >= 100) saettigung = 100;
           helligkeit = brightness(farbWert);//*werte;
       bildBearbeitet.pixels[i + j*w] = color(farbe,farbsaettigung,helligkeit);
     } 
   }

  
   return bildBearbeitet;
 }
 
 